<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Home - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="install.html">install</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="install.html#.install_as_user">install_as_user</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_as_developer">install_as_developer</a></li><li data-type='method' style='display: none;'><a href="install.html#.install_a_new_package">install_a_new_package</a></li></ul></li><li><a href="make.html">make</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="make.html#.build">build</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_cpp">build_cpp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_gyp">build_gyp</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_python">build_python</a></li><li data-type='method' style='display: none;'><a href="make.html#.build_public">build_public</a></li><li data-type='method' style='display: none;'><a href="make.html#.test">test</a></li><li data-type='method' style='display: none;'><a href="make.html#.clean">clean</a></li><li data-type='method' style='display: none;'><a href="make.html#.sync">sync</a></li><li data-type='method' style='display: none;'><a href="make.html#.show">show</a></li><li data-type='method' style='display: none;'><a href="make.html#.usage">usage</a></li><li data-type='method' style='display: none;'><a href="make.html#.install">install</a></li></ul></li><li><a href="jsdoc2.html">jsdoc2</a></li></ul><h3>Global</h3><ul><li><a href="global.html#make-readme">make-readme</a></li><li><a href="global.html#menu">menu</a></li></ul>
    
</nav>

<div id="main">
    

    



    


    <section class="package">
        <h3> </h3>		
    </section>









    



    <section class="readme usertext">
        <article><h1>aidebuild</h1>
<p>Builds multi-language compilation packages and related documentation.</p>
<div style='float:right;margin-left:20px'><a target=_blank' href='https://line.gitlabpages.inria.fr/aide-group/aide/index.html'><img alt='AIDE API docs' src='https://line.gitlabpages.inria.fr/aide-group/aide/img/icons8-api-aide.png'/></a></div>
<h2>Description</h2>
<p>This packages provides utilities to develop and publish modular tools for web based applications.</p>
<ul>
<li>It is based on the <a href="https://www.npmjs.com">npmjs</a> package system</li>
</ul>
<h3>Technical choices</h3>
<p>The code is expected to be a set of <a href="http://www.cplusplus.com/reference">C/C++</a> and <a href="https://www.w3schools.com/jsref">JavaScript</a> source files, and a <a href="https://www.python.org">Python</a> wrapper is available.</p>
<p>As a web service, it implements a local node.js server, and wrap C/C++ code using the <a href="https://github.com/nodejs/node-addon-examples">node-addon-api</a>, as defined the <a href="https://line.gitlabpages.inria.fr/aide-group/aideweb/">aideweb</a> package.</p>
<p>The documentation uses <a href="https://www.markdownguide.org/basic-syntax">markdown syntax</a> and <a href="https://jsdoc.app/">JsDoc tags</a>, with the <a href="https://www.npmjs.com/package/jsdoc">jsdoc</a> mechanism and the <a href="https://www.npmjs.com/package/docdash">docdash</a> theme. Documentation generation includes source files normalization (i.e., beautifying or uncrustification), multi-language documentation generation and production of images or PDF from LaTeX formula or latex or libreoffice drawing files.</p>
<h3>Coding rules</h3>
<p>A few simple coding rules allows multi-language development to be smooth and easy.</p>
<h4>Notion of factory</h4>
<p>When object oriented programming is not necessary, static methods are encapsulated in &quot;factories&quot;, i.e., group of functions, accessible via the factory name, e.g., <code>aidesys::regexMatch(string, regex);</code> in C++ or <code>slugstring.fill(dictionary);</code> in JavaScript, thus without class object instance.</p>
<ul>
<li>
<p>Naming conventions:</p>
<ul>
<li>Factory names are all in lower-case.</li>
<li>Static method names are verbs, in lower-case. Compounded names use the <a href="https://en.wikipedia.org/wiki/Camel_case">camelCase</a> convention.</li>
<li>Static methods parameters names are nouns. Compounded parameters names hyphenation use the underscore <code>_</code> hyphen, including JSON tuples data names.</li>
</ul>
</li>
<li>
<p>Parameters type:</p>
<ul>
<li>Boolean <code>bool</code>, integer <code>int</code> (or <code>uint</code> if unsigned), <code>double</code> (for floating point values) and <code>string</code> are the used scalar values (i.e. literals).</li>
<li>Otherwise, parameters are objects, defined via classes.</li>
</ul>
</li>
</ul>
<h4>Notion of Classes</h4>
<ul>
<li>
<p>For multi-language call, classes better use:</p>
<ul>
<li>Parameter-less constructor (which is fine also for internal language use).</li>
<li>Setters: i.e., <code>set(value)</code> method to set the whole object, and <code>set(name, value)</code> to set an object parameter.</li>
<li>Getters: i.e., <code>get(name)</code> or <code>getName()</code> method to get an object parameter or <code>isName()</code> to get a boolean value parameter.
<ul>
<li>The <code>at(name)</code> method does not create a default value while the <code>get(name)</code> may create an entry for this parameter (in coherence with a subscript <code>[]</code> operator.</li>
<li>The object <code>size()</code> or <code>count()</code> methods are not prefixed by get in coherence with the main usage.</li>
</ul>
</li>
<li>Casters: e.g., <code>asString()</code> to get the whole representation as a string (with similar convention for other convention).</li>
</ul>
</li>
<li>
<p>Naming conventions:</p>
<ul>
<li>Class names are nouns, instance names are verbs. Compounded names use the <a href="https://en.wikipedia.org/wiki/Camel_case">camelCase</a> convention, methods parameters are nouns, using underscore <code>_</code> hyphen.</li>
<li>The <code>toString()</code> method is prohibited, because of Python wrapping.</li>
</ul>
</li>
</ul>
<p><a name='what'></a></p>
<h2>Package repository</h2>
<ul>
<li>Package files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/aidebuild'>https://gitlab.inria.fr/line/aide-group/aidebuild</a></li>
<li>Package documentation: <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild'>https://line.gitlabpages.inria.fr/aide-group/aidebuild</a></li>
<li>Source files: <a target='_blank' href='https://gitlab.inria.fr/line/aide-group/aidebuild/-/tree/master/src'>https://gitlab.inria.fr/line/aide-group/aidebuild/-/tree/master/src</a></li>
<li>Saved on <a target='_blank' href='https://archive.softwareheritage.org/browse/origin/directory/?origin_url=https://gitlab.inria.fr/line/aide-group/aidebuild'>softwareherirage.org</a></li>
<li>Version <code>1.1.2</code></li>
<li>License <code>CECILL-C</code></li>
</ul>
<h2>Installation</h2>
<h3>User simple installation</h3>
<ul>
<li><code>npm install git+https://gitlab.inria.fr/line/aide-group/aidebuild.git</code></li>
</ul>
<h3>Co-developper installation</h3>
<ul>
<li>See the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html#.install_as_developer'>related documentation</a></li>
</ul>
<p>Please refer to the <a target='_blank' href='https://line.gitlabpages.inria.fr/aide-group/aidebuild/install.html'>installation guide</a> for installation.</p>
<p><a name='how'></a></p>
<h2>Usage</h2>
<h3>npm script usage</h3>
<pre class="prettyprint source"><code>npm install --quiet : installs all package dependencies and sources.
npm run build: builds the different compiled, documentation and test files.
npm test     : runs functional and non-regression tests.
npm run clean: cleans installation files.
</code></pre>
<p><a name='dep'></a></p>
<h2>Dependencies</h2>
<ul>
<li><tt>cligui2: <a target='_blank' href='https://github.com/ThreeLetters/CLI-GUI2#readme'>ClI-GUI but better. Beautiful graphical interface on command line </a></tt></li>
<li><tt>docdash: <a target='_blank' href='https://github.com/clenemt/docdash.git'>A clean, responsive documentation template theme for JSDoc 3 inspired by lodash and minami</a></tt></li>
<li><tt>js-beautify: <a target='_blank' href='https://beautifier.io/'>beautifier.io for node</a></tt></li>
<li><tt>jsdoc: <a target='_blank' href='https://github.com/jsdoc/jsdoc'>An API documentation generator for JavaScript.</a></tt></li>
<li><tt>uglify-js: <a target='_blank' href='https://www.npmjs.com/package/uglify-js'>JavaScript parser, mangler/compressor and beautifier toolkit</a></tt></li>
</ul>
<p><a name='who'></a></p>
<h2>Author</h2>
<ul>
<li>Thierry Viéville <a href="mailto:thierry.vieville@inria.fr">thierry.vieville@inria.fr</a></li>
</ul></article>
    </section>






    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>